# flow
A wave module solving the Full Potential Equation

![](/dox/flow.png)

## Main features
* [x] Meshes generated with gmsh
* [x] 2D (Line2 and Tri3 elements) and 3D (Tri3 and Tetra4 elements) simulations
* [x] Picard or Newton-Raphson outer solver
  - full analytical tangent matrix
  - linesearch: 3 points quadratic (backtracking for debug)
  - artificial viscosity ramping
* [x] MUMPS inner solver
* [x] Kutta condition implemented through direct matrix manipulation (cfr. Nishida, Galbraith)
* [x] Artificial viscosity computed with best-upstream-alignement strategy
* [x] Variables extracted at nodes, saved in vtk or gmsh format (volume) and in ascii (boundary) for post-processing
* [x] Capability to integrate/interpolate variables on elements of boundaries
* [x] CUPyDO ready (mesh deformed with linear elasticity laws)

## Sub-modules
* [tests](flow/tests): simple tests to be run in battery checking the basic functionnalities of the solver
* [validation](flow/validation): large scale tests used to validate the solver results
* [cases](flow/cases) : sample configuration files meant to be run with scripts, user-defined case should be derived from these
* [scripts](flow/scripts): various scripts for running the solver automatically
