from builtins import str
from builtins import range
import numpy as np
import os
from katropton.Juelich.post_process.vtk_post_process_2 import post_process
from katropton.Juelich.post_process.vtk_post_process_2 import post_process_mirror


def cuts(filename, filename_ref, dz1, T1, dz2, T2, remove_ref=False):
    p_cut = np.array([5.971051450397588, 20.29345703125, -26.85714554786682])
    n_cut = np.array([1., 0., 0.])

    directory = 'cut_1'
    if not os.path.exists(directory):
        os.makedirs(directory)
    os.chdir(directory)

    post_process(filename=filename,
                 filename_ref=filename_ref,
                 remove_ref=remove_ref,
                 p_cut=p_cut,
                 scale_u=1. / 1000.,
                 scale_T=1.,
                 n_cut=n_cut,
                 T_range=T1,
                 dz_range=dz1)

    os.chdir('..')

    directory = 'cut_2'
    if not os.path.exists(directory):
        os.makedirs(directory)
    os.chdir(directory)

    p_cut = np.array(
        [24.91341173426381, 4.525806024554082, -26.975820456076352])
    n_cut = np.array([0.20170202470821563, -0.9790050766051117, 0.])

    post_process(filename=filename,
                 filename_ref=filename_ref,
                 remove_ref=remove_ref,
                 p_cut=p_cut,
                 scale_u=1. / 1000.,
                 scale_T=1.,
                 n_cut=n_cut,
                 T_range=T2,
                 dz_range=dz2)

    os.chdir('..')


def cuts_all_N(N, case_id, ref_case_id, case_name, remove_ref, T1, Z1, T2, Z2):
    file_dir = os.path.dirname(__file__)
    for i in range(0, N):
        directory = 'point_' + str(i) + '_' + case_name
        if not os.path.exists(directory):
            os.makedirs(directory)
        os.chdir(directory)
        base_dir = file_dir + '/../../../workspace/katropton_Juelich_tests_M1_assembly_fused/MPI_2/' + case_id + '/1/' + str(
            i)
        base_dir_ref = file_dir + '/../../../workspace/katropton_Juelich_tests_M1_assembly_fused/MPI_2/' + ref_case_id + '/1/' + str(
            i)
        cuts(base_dir + '/fused_mirror_assembly_mm_part_2_ast1_s0.pvtu',
             base_dir_ref + '/fused_mirror_assembly_mm_part_2_ast1_s0.pvtu',
             dz1[i, :], T1[i, :], dz2[i, :], T2[i, :], remove_ref=remove_ref)
        post_process_mirror(filename=base_dir + '/mirror_data_all.npz',
                            filename_ref=base_dir_ref + '/mirror_data_all.npz',
                            remove_ref=remove_ref)
        os.chdir('..')


if __name__ == "__main__":

    N = 2

    T1 = np.zeros((N, 2))
    dz1 = np.zeros((N, 2))

    T2 = np.zeros((N, 2))
    dz2 = np.zeros((N, 2))

    T1[0, :] = [70, 120.00236433]
    T1[1, :] = [70, 160.19321603]

    T2[0, :] = [70, 120.00236433]
    T2[1, :] = [70, 160.19321603]

    #cuts_all_N(N, 'A2', 'A2_baking', 'A', False, T, Z)
    #cuts_all_N(N, 'B2', 'B2_baking', 'B', False, T, Z)

    dz1[0, :] = [5e-07, 2e-05]
    dz1[1, :] = [-1.5e-06, 4e-05]

    dz2[0, :] = [-2.5e-05, 2.1e-05]
    dz2[1, :] = [-5e-05, 5e-05]
    '''
    dz1[0, :] = [5e-07, 1.5e-05]
    dz1[1, :] = [-1.5e-06, 4e-05]

    dz2[0, :] = [-2.5e-05, 1.6e-05]
    dz2[1, :] = [-5e-05, 5e-05]    
    '''
    cuts_all_N(N, 'A2', 'A2_baking', 'A_diff', True, T1, dz1, T2, dz2)
    '''
    dz1[0, :] = [1.9e-06, 2e-05]
    dz1[1, :] = [1e-06, 4e-05]

    dz2[0, :] = [-2.1e-05, 2.1e-05]
    dz2[1, :] = [-5e-05, 5e-05]    
    '''
    cuts_all_N(N, 'B2', 'B2_baking', 'B_diff', True, T1, dz1, T2, dz2)
