

clear all
close all
clc
format long

L = 1;
n = 21;

nu1 = 10;
nu2 = 10;

eigeninitialguess = 1;
numeigenvectors = n;
ndisplay = n*10;
b_eigenvectors = [];%[1,12];
b_coeff = [];%[1/20,4];

omega = 1/4;
dimension = 1;
display = 0;

%%
[ Ah,Ahh,h ] = oneDLaplacianMatrix( n, L );

V = zeros(n,n);
for k =1:n
    for i =1:n
        V(i,k) = sin(i*k*pi/(n+1));
    end
end


[Vh,Dh] = eig(Ah);

tmp = diag(V'*Vh);
for i=1:n
   if tmp(i) < 0
       Vh(:,i) = -Vh(:,i);
   end
end


x = zeros(n,1);
xdisplay = (linspace(0,1,ndisplay))';
ydisplay = zeros(ndisplay,1);
if eigeninitialguess
    for k =1:numeigenvectors
        x = x + sin(k*pi*(h:h:(L-h))');%Vh(:,k);
        ydisplay = ydisplay + sin(k*pi*xdisplay);%+ max(Vh(:,k))*sin(k*pi*xdisplay)/max(sin(k*pi*xdisplay));
    end
else
    x = rand(n,1)-0.5;%V(:,1)+V(:,5)+V(:,21)+V(:,29)+V(:,209);
    maxx = max(abs(x));
    x = x / maxx;
end
b =  zeros(size(x));
for i =1:length(b_coeff) 
    b = b + b_coeff(i)*sin(b_eigenvectors(i)*pi*(h:h:(L-h))');
end

x_old = x;
[x,M,x1,xH1,xH,xcc,AH,I_h_H,I_H_h] = twoGridCycle(x,Ah,b,omega,nu1,nu2,dimension,display,L,h);
x_new = x;

max(abs(x))


[VH,DH] = eig(AH);

tmp = diag(VH'*I_h_H*Vh);
for i=1:((n-1)/2)
   VH(:,i) = VH(:,i)/tmp(i); % change the norm 
end

scrsz = get(groot,'Screensize');
figure('Position',[1 1 scrsz(3) scrsz(4)])
subplot(2,1,1)
plot([0:h:L],[0;x_old;0],'linewidth',3)
hold on
plot([0:h:L],[0;x1;0],'linewidth',3)
plot([0:2*h:L],[0;xH1;0],'linewidth',3)
plot([0:2*h:L],[0;xH;0],'linewidth',3)
plot([0:h:L],[0;xcc;0],'linewidth',3)

box on 
grid on 
plot([0:h:L],[0;x_new;0],'linewidth',3)
if eigeninitialguess
    plot(xdisplay,ydisplay,'--','linewidth',2)
end
hold off
legend('initial guess','smoothed guess','smoothed guess on coars mesh','coars mesh solution','coars corrected','smoothed corrected' ,'Location','northoutside','Orientation','horizontal')


subplot(2,1,2)
plot(0:(n-1),Vh'*x_old,'linewidth',3)
hold on
plot(0:(n-1),Vh'*x1,'linewidth',3)
plot(0:((n-1)/2-1),VH'*xH1,'linewidth',3)
plot(0:((n-1)/2-1),VH'*xH,'linewidth',3)
plot(0:(n-1),Vh'*xcc,'linewidth',3)
box on 
grid on 
plot(0:(n-1),Vh'*x_new,'linewidth',3)

%plot(0:((n-1)/2-1),VH'*I_h_H*x_old,'linewidth',3)

xlim([0,n-1])
hold off


B = Ah;
[V,D] = eig(B);
d = diag(D);
figure
subplot(2,3,1)
plot(real(d),imag(d),'o')
axis equal
subplot(2,3,4)
nbins = 100;
hist(real(d),nbins)

B = M;
[V,D] = eig(B);
d = diag(D);
subplot(2,3,2)
plot(real(d),imag(d),'o')
axis equal
subplot(2,3,5)
nbins = 100;
hist(real(d),nbins)

B = M*Ah;
[V,D] = eig(B);
d = diag(D);
subplot(2,3,3)
plot(real(d),imag(d),'o')
axis equal
subplot(2,3,6)
nbins = 100;
hist(real(d),nbins)

% B\(M*b)
% Ah\b
% x_new

