#include "wSource.h"
#include "wProblem.h"
#include "wTag.h"
#include "wElement.h"
#include "wNode.h"
#include <algorithm>
using namespace katropton;
using namespace tbox;

/**
 * @brief Source constructor
 * 
 * Arguments:
 * <ul>
 *  <li> pbl: a Problem object,
 *  <li> name: the name of the constrained surface of the msh,
 *  <li> _Source_name: the name of new Source (does not have to be a nametag of the msh),
 *  <li> v_T: value of the volumetric heat source.
 * </ul>
 */
Source::Source(Problem &pbl,
               std::string const &name,
               std::string const &_Source_name,
               double v_T) : Group(pbl.msh, name), Source_name(_Source_name), value(v_T)
{
    for (auto e : tag->elems)
        for (auto n : e->nodes)
            nodes.push_back(n);

    pbl.Sources.push_back(this);
}

/**
 * @brief Display information.
 */
void Source::write(std::ostream &out) const
{
    out << "Source on " << *tag << "\n";
    out << "Value " << value << "\n";
}
