#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from fwk.coloring import ccolors
import tbox

## Check and set linear (inner) third-party solver
#
# Adrien Crovato
class LinearSolver:
    def __init__(self):
        pass
    def pardiso(self):
        try:
            return tbox.Pardiso()
        except:
            print(ccolors.ANSI_YELLOW + 'Intel MKL Pardiso not found, using SparseLU (Eigen) instead!' + ccolors.ANSI_RESET)
            return tbox.SparseLu()
    def mumps(self):
        try:
            return tbox.Mumps()
        except:
            print(ccolors.ANSI_YELLOW + 'MUMPS not found, using SparseLU (Eigen) instead!' + ccolors.ANSI_RESET)
            return tbox.SparseLu()
