#! /usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


from __future__ import print_function
import tboxVtk
import tbox.gmsh as gmsh

def main():
    msh = gmsh.MeshLoader("models/model.geo",__file__).execute()
    printtags(msh)

    vtkWriter = tboxVtk.VtkExport(msh)
    print(vtkWriter)
    vtkWriter.binary = False
    vtkWriter.save(msh.name)

def printtags(mshdata):
    print("\n-ptags:")
    for t in list(mshdata.ptags.items()):
        print(t[1])
    print("\n-etags:")
    for t in list(mshdata.etags.items()):
        print(t[1])
    print("\n-partitions:")
    for t in list(mshdata.parts.items()):
        print(t[1])

if __name__ == "__main__":
    main()
    
